Main Page Widgets Namespaces Book

# Gtk::Clipboard Class Reference

Inheritance diagram for Gtk::Clipboard:

[legend]
List of all members.

## Detailed Description

The Clipboard object represents a clipboard of data shared between different processes or between different widgets in the same process.

Each clipboard is identified by a name encoded as a GdkAtom. * (Conversion to and from strings can be done with gdk_atom_intern() and gdk_atom_name().) The default clipboard corresponds to the "CLIPBOARD" atom; another commonly used clipboard is the "PRIMARY" clipboard, which, in X, traditionally contains the currently selected text.

To support having a number of different formats on the clipboard at the same time, the clipboard mechanism allows providing callbacks instead of the actual data. When you set the contents of the clipboard, you can either supply the data directly (via functions like set_text()), or you can supply a callback to be called at a later time when the data is needed (via set().) Providing a callback also avoids having to make copies of the data when it is not needed.

Requesting the data from the clipboard is essentially asynchronous. If the contents of the clipboard are provided within the same process, then a direct function call will be made to retrieve the data, but if they are provided by another process, then the data needs to be retrieved from the other process, which may take some time. To avoid blocking the user interface, the call to request the selection, request_contents() takes a callback that will be called when the contents are received (or when the request fails.) If you don't want to deal with providing a separate callback, you can also use wait_for_contents(). This runs the GLib main loop recursively waiting for the contents. This can simplify the code flow, but you still have to be aware that other callbacks in your program can be called while this recursive mainloop is running.

Along with the functions to get the clipboard contents as an arbitrary data chunk, there are also functions to retrieve it as text, request_text() and wait_for_text(). These functions take care of determining which formats are advertised by the clipboard provider, asking for the clipboard in the best available format and converting the results into the UTF-8 encoding.

## Public Types
typedef sigc::slot<void> | SlotClear
| For instance: void on_clear();.
typedef sigc::slot< void, SelectionData&, guint > | SlotGet
| For instance: void on_get(Gtk::SelectionData& selection_data, guint info);.
typedef sigc::slot< void, const Glib::RefPtr<Gdk::Pixbuf >&> | SlotImageReceived
| For instance: void on_image_received(const Glib::RefPtr<Gdk::Pixbuf>& text);.
typedef sigc::slot< void, const SelectionData& > | SlotReceived
| For instance: void on_received(const SelectionData& selection_data);.
typedef sigc::slot< void, const Glib::ustring &, const std::string& > | SlotRichTextReceived
| For instance: void on_rich_text_received(const Glib::ustring& format, const std::string& text);.
typedef sigc::slot< void, const Glib::StringArrayHandle& > | SlotTargetsReceived
| For instance: void on_targetsreceived(const Glib::StringArrayHandle& targets);.
typedef sigc::slot< void, const Glib::ustring& > | SlotTextReceived
| For instance: void on_text_received(const Glib::ustring& text);.
## Public Member Functions
void | clear ()
| Clears the contents of the clipboard.
Glib::RefPtr<const Gdk::Display> | get_display () const
| Gets the Gdk::Display associated with clipboard.
Glib::RefPtr<Gdk::Display> | get_display ()
| Gets the Gdk::Display associated with clipboard.
Glib::RefPtr<const Glib::Object> | get_owner () const
| If the clipboard contents callbacks were set with gtk_clipboard_set_with_owner(), and the gtk_clipboard_set_with_data() or gtk_clipboard_clear() has not subsequently called, returns the owner set by gtk_clipboard_set_with_owner().
Glib::RefPtr<Glib::Object> | get_owner ()
| If the clipboard contents callbacks were set with gtk_clipboard_set_with_owner(), and the gtk_clipboard_set_with_data() or gtk_clipboard_clear() has not subsequently called, returns the owner set by gtk_clipboard_set_with_owner().
const GtkClipboard* | gobj () const
| Provides access to the underlying C GObject.
GtkClipboard* | gobj ()
| Provides access to the underlying C GObject.
GtkClipboard* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
void | request_contents (const Glib::ustring& target, const SlotReceived& slot)
| Requests the contents of clipboard as the given target.
void | request_image (const SlotImageReceived& slot)
| Requests the contents of the clipboard as image.
void | request_rich_text (const Glib::RefPtr<TextBuffer>& buffer, const SlotRichTextReceived& slot)
| Requests the contents of the clipboard as rich text.
void | request_targets (const SlotTargetsReceived& slot)
| Requests the contents of the clipboard as list of supported targets.
void | request_text (const SlotTextReceived& slot)
| Requests the contents of the clipboard as text.
bool | set (const ArrayHandle_TargetEntry& targets, const SlotGet& slot_get, const SlotClear& slot_clear)
| Virtually sets the contents of the specified clipboard by providing a list of supported formats for the clipboard data and a function to call to get the actual data when it is requested.
void | set_can_store ()
| Hints that all forms of clipboard data should be stored somewhere when the application exits or when store() is called.
void | set_can_store (const ArrayHandle_TargetEntry& targets)
| Hints that the clipboard data should be stored somewhere when the application exits or when store() is called.
void | set_image (const Glib::RefPtr<Gdk::Pixbuf>& pixbuf)
| Sets the contents of the clipboard to the given Gdk::Pixbuf.
void | set_text (const Glib::ustring& text)
| Sets the contents of the clipboard to the given UTF-8 string.
Glib::SignalProxy1< void, GdkEventOwnerChange* > | signal_owner_change ()
| Prototype: `void on_my_owner_change(GdkEventOwnerChange* event)`
void | store ()
| Stores the current clipboard data somewhere so that it will stay around after the application has quit.
SelectionData | wait_for_contents (const Glib::ustring& target) const
| Requests the contents of the clipboard using the given target.
Glib::RefPtr<Gdk::Pixbuf> | wait_for_image () const
| Requests the contents of the clipboard as image and converts the result to a Gdk::Pixbuf.
std::string | wait_for_rich_text (const Glib::RefPtr<TextBuffer>& buffer, std::string& format)
Glib::StringArrayHandle | wait_for_targets () const
| Returns a list of targets that are present on the clipboard.
Glib::ustring | wait_for_text () const
| Requests the contents of the clipboard as text and converts the result to UTF-8 if necessary.
bool | wait_is_image_available () const
| Test to see if there is an image available to be pasted This is done by requesting the TARGETS atom and checking if it contains any of the supported image targets.
bool | wait_is_rich_text_available (const Glib::RefPtr<TextBuffer>& buffer) const
| Test to see if there is rich text available to be pasted This is done by requesting the TARGETS atom and checking if it contains any of the supported rich text targets.
bool | wait_is_target_available (const Glib::ustring& target)
| Checks if a clipboard supports pasting data of a given type.
bool | wait_is_text_available () const
| Test to see if there is text available to be pasted This is done by requesting the TARGETS atom and checking if it contains any of the supported text targets.
virtual | ~Clipboard ()
## Static Public Member Functions
static Glib::RefPtr<Clipboard> | get (GdkAtom selection=GDK_SELECTION_CLIPBOARD)
| Return value: the appropriate clipboard object.
static Glib::RefPtr<Clipboard> | get_for_display (const Glib::RefPtr<Gdk::Display>& display, GdkAtom selection=GDK_SELECTION_CLIPBOARD)
| Return value: the appropriate clipboard object.
## Related Functions
(Note that these are not member functions.)
Glib::RefPtr<Gtk::Clipboard> | wrap (GtkClipboard* object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Member Typedef Documentation

typedef sigc::slot<void> Gtk::Clipboard::SlotClear

For instance: void on_clear();.

typedef sigc::slot<void, SelectionData&, guint> Gtk::Clipboard::SlotGet

For instance: void on_get(Gtk::SelectionData& selection_data, guint info);.

typedef sigc::slot<void, const Glib::RefPtr<Gdk::Pixbuf>&> Gtk::Clipboard::SlotImageReceived

For instance: void on_image_received(const Glib::RefPtr<Gdk::Pixbuf>& text);.

typedef sigc::slot<void, const SelectionData&> Gtk::Clipboard::SlotReceived

For instance: void on_received(const SelectionData& selection_data);.

typedef sigc::slot<void, const Glib::ustring& , const std::string&> Gtk::Clipboard::SlotRichTextReceived

For instance: void on_rich_text_received(const Glib::ustring& format, const std::string& text);.

typedef sigc::slot<void, const Glib::StringArrayHandle&> Gtk::Clipboard::SlotTargetsReceived

For instance: void on_targetsreceived(const Glib::StringArrayHandle& targets);.

typedef sigc::slot<void, const Glib::ustring&> Gtk::Clipboard::SlotTextReceived

For instance: void on_text_received(const Glib::ustring& text);.

## Constructor & Destructor Documentation

virtual Gtk::Clipboard::~Clipboard | ( |  | ) | `[virtual]`

## Member Function Documentation

void Gtk::Clipboard::clear | ( |  | ) |

Clears the contents of the clipboard.

Generally this should only be called between the time you call gtk_clipboard_set_with_owner() or gtk_clipboard_set_with_data(), and when the clear_func you supplied is called. Otherwise, the clipboard may be owned by someone else.

static Glib::RefPtr<Clipboard> Gtk::Clipboard::get | ( | GdkAtom | selection = `GDK_SELECTION_CLIPBOARD` | ) | `[static]`

Return value: the appropriate clipboard object.

If no

Parameters:

  | selection | A Gdk::Atom which identifies the clipboard to use.

Returns:
  The appropriate clipboard object. If no clipboard already exists, a new one will be created. Once a clipboard object has been created, it is persistent and, since it is owned by GTK+, must not be freed or unrefd.

Glib::RefPtr<const Gdk::Display> Gtk::Clipboard::get_display | ( |  | ) | const

Gets the Gdk::Display associated with clipboard.

Returns:
  The Gdk::Display associated with clipboard

Since gtkmm 2.2:

Glib::RefPtr<Gdk::Display> Gtk::Clipboard::get_display | ( |  | ) |

Gets the Gdk::Display associated with clipboard.

Returns:
  The Gdk::Display associated with clipboard

Since gtkmm 2.2:

static Glib::RefPtr<Clipboard> Gtk::Clipboard::get_for_display | ( | const Glib::RefPtr<Gdk::Display>& | display,
|  | GdkAtom | selection = `GDK_SELECTION_CLIPBOARD` |
| ) |  |  | `[static]`

Return value: the appropriate clipboard object.

If no

Parameters:

  | display | The display for which the clipboard is to be retrieved or created.
  | selection | A Gdk::Atom which identifies the clipboard to use.

Returns:
  The appropriate clipboard object. If no clipboard already exists, a new one will be created. Once a clipboard object has been created, it is persistent and, since it is owned by GTK+, must not be freed or unrefd.

Since gtkmm 2.2:

Glib::RefPtr<const Glib::Object> Gtk::Clipboard::get_owner | ( |  | ) | const

If the clipboard contents callbacks were set with gtk_clipboard_set_with_owner(), and the gtk_clipboard_set_with_data() or gtk_clipboard_clear() has not subsequently called, returns the owner set by gtk_clipboard_set_with_owner().

Returns:
  The owner of the clipboard, if any; otherwise `0`.

Glib::RefPtr<Glib::Object> Gtk::Clipboard::get_owner | ( |  | ) |

If the clipboard contents callbacks were set with gtk_clipboard_set_with_owner(), and the gtk_clipboard_set_with_data() or gtk_clipboard_clear() has not subsequently called, returns the owner set by gtk_clipboard_set_with_owner().

Returns:
  The owner of the clipboard, if any; otherwise `0`.

const GtkClipboard* Gtk::Clipboard::gobj | ( |  | ) | const`[inline]`

Provides access to the underlying C GObject.

Reimplemented from Glib::ObjectBase.

GtkClipboard* Gtk::Clipboard::gobj | ( |  | ) | `[inline]`

Provides access to the underlying C GObject.

Reimplemented from Glib::ObjectBase.

GtkClipboard* Gtk::Clipboard::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

void Gtk::Clipboard::request_contents | ( | const Glib::ustring & | target,
|  | const SlotReceived& | slot |
| ) |  |  |

Requests the contents of clipboard as the given target.

When the results of the result are later received the supplied callback will be called.

Parameters:

  | target | The form into which the clipboard owner should convert the selection.
  | slot | A function to call when the results are received (or the retrieval fails). If the retrieval fails the length field of selection_data will be negative.

void Gtk::Clipboard::request_image | ( | const SlotImageReceived& | slot | ) |

Requests the contents of the clipboard as image.

When the image is later received, it will be converted to a Gdk::Pixbuf. This function waits for the data to be received using the main loop, so events, timeouts, etc, may be dispatched during the wait.

The pixbuf parameter to slot will contain the resulting pixbuf if the request succeeded, or will be empty if it failed. This could happen for various reasons, in particular if the clipboard was empty or if the contents of the clipboard could not be converted into image form.

Parameters:

  | slot,: | a function to call when the text is received, or the retrieval fails. (It will always be called one way or the other.)

void Gtk::Clipboard::request_rich_text | ( | const Glib::RefPtr<TextBuffer>& | buffer,
|  | const SlotRichTextReceived& | slot |
| ) |  |  |

Requests the contents of the clipboard as rich text.

When the rich text is later received, callback will be called.

The text parameter to the callback will contain the resulting rich text if the request succeeded, or an empty string if it failed. This function can fail for various reasons, in particular if the clipboard was empty or if the contents of the clipboard could not be converted into rich text form.

Parameters:

  | slot,: | a function to call when the text is received, or the retrieval fails. (It will always be called one way or the other.)

void Gtk::Clipboard::request_targets | ( | const SlotTargetsReceived& | slot | ) |

Requests the contents of the clipboard as list of supported targets.

When the list is later received, callback will be called.

The targets parameter to slot will contain the resulting targets if the request succeeded.

Parameters:

  | slot | a function to call when the targets are received, or the retrieval fails. (It will always be called one way or the other.) Remember that Glib::StringArrayHandle is an intermediate type, so you should convert it to a standard C++ container.

Since gtkmm 2.4:

void Gtk::Clipboard::request_text | ( | const SlotTextReceived& | slot | ) |

Requests the contents of the clipboard as text.

When the text is later received, it will be converted to UTF-8 if necessary, and slot will be called.

The text parameter to slot will contain the resulting text if the request succeeded, or will be empty if it failed. This could happen for various reasons, in particular if the clipboard was empty or if the contents of the clipboard could not be converted into text form.

Parameters:

  | slot,: | a function to call when the text is received, or the retrieval fails. (It will always be called one way or the other.)

bool Gtk::Clipboard::set | ( | const ArrayHandle_TargetEntry & | targets,
|  | const SlotGet& | slot_get,
|  | const SlotClear& | slot_clear |
| ) |  |  |

Virtually sets the contents of the specified clipboard by providing a list of supported formats for the clipboard data and a function to call to get the actual data when it is requested.

Parameters:

  | targets | Information about the available forms for the clipboard data.
  | slot_get | method to call to get the actual clipboard data.
  | slot_clear | When the clipboard contents are set again, this method will be called, and slot_get will not be subsequently called.

Returns:
  true if setting the clipboard data succeeded. If setting the clipboard data failed then the provided callback methods will be ignored.

void Gtk::Clipboard::set_can_store | ( |  | ) |

Hints that all forms of clipboard data should be stored somewhere when the application exits or when store() is called.

This value is reset when the clipboard owner changes. Where the clipboard data is stored is platform dependent, see Gdk::Display::store_clipboard() for more information.

void Gtk::Clipboard::set_can_store | ( | const ArrayHandle_TargetEntry & | targets | ) |

Hints that the clipboard data should be stored somewhere when the application exits or when store() is called.

This value is reset when the clipboard owner changes. Where the clipboard data is stored is platform dependent, see Gdk::Display::store_clipboard() for more information.

Parameters:

  | targets | Array containing information about which forms should be stored.

void Gtk::Clipboard::set_image | ( | const Glib::RefPtr<Gdk::Pixbuf>& | pixbuf | ) |

Sets the contents of the clipboard to the given Gdk::Pixbuf.

GTK+ will take responsibility for responding for requests for the image, and for converting the image into the requested format.

Since gtkmm 2.6:

Parameters:

  | pixbuf | A Gdk::Pixbuf.

void Gtk::Clipboard::set_text | ( | const Glib::ustring & | text | ) |

Sets the contents of the clipboard to the given UTF-8 string.

GTK+ will make a copy of the text and take responsibility for responding for requests for the text, and for converting the text into the requested format.

Parameters:

  | text | A UTF-8 string.

Glib::SignalProxy1< void,GdkEventOwnerChange* > Gtk::Clipboard::signal_owner_change | ( |  | ) |

Prototype:
  `void on_my_owner_change(GdkEventOwnerChange* event)`

void Gtk::Clipboard::store | ( |  | ) |

Stores the current clipboard data somewhere so that it will stay around after the application has quit.

Since gtkmm 2.6:

SelectionData Gtk::Clipboard::wait_for_contents | ( | const Glib::ustring & | target | ) | const

Requests the contents of the clipboard using the given target.

This function waits for the data to be received using the main loop, so events, timeouts, etc, may be dispatched during the wait.

Parameters:

  | target | The form into which the clipboard owner should convert the selection.

Returns:
  A SelectionData object, which will be invalid if retrieving the given target failed.

Glib::RefPtr<Gdk::Pixbuf> Gtk::Clipboard::wait_for_image | ( |  | ) | const

Requests the contents of the clipboard as image and converts the result to a Gdk::Pixbuf.

This function waits for the data to be received using the main loop, so events, timeouts, etc, may be dispatched during the wait.

Returns:
  A newly-allocated Gdk::Pixbuf object which must be disposed with Glib::object_unref(), or `0` if retrieving the selection data failed. (This could happen for various reasons, in particular if the clipboard was empty or if the contents of the clipboard could not be converted into an image.)

Since gtkmm 2.6:

std::string Gtk::Clipboard::wait_for_rich_text | ( | const Glib::RefPtr<TextBuffer>& | buffer,
|  | std::string & | format |
| ) |  |  |

Glib::StringArrayHandle Gtk::Clipboard::wait_for_targets | ( |  | ) | const

Returns a list of targets that are present on the clipboard.

This function waits for the data to be received using the main loop, so events, timeouts, etc, may be dispatched during the wait.

Returns:
  targets: The targets.

Since gtkmm 2.4:

Glib::ustring Gtk::Clipboard::wait_for_text | ( |  | ) | const

Requests the contents of the clipboard as text and converts the result to UTF-8 if necessary.

This function waits for the data to be received using the main loop, so events, timeouts, etc, may be dispatched during the wait.

Returns:
  A UTF-8 string, which is empty if retrieving the selection data failed. (This could happen for various reasons, in particular if the clipboard was empty or if the contents of the clipboard could not be converted into text form.).

bool Gtk::Clipboard::wait_is_image_available | ( |  | ) | const

Test to see if there is an image available to be pasted This is done by requesting the TARGETS atom and checking if it contains any of the supported image targets.

This function waits for the data to be received using the main loop, so events, timeouts, etc, may be dispatched during the wait.

This function is a little faster than calling gtk_clipboard_wait_for_image() since it doesn't need to retrieve the actual image data.

Returns:
  `true` is there is an image available, `false` otherwise.

Since gtkmm 2.6:

bool Gtk::Clipboard::wait_is_rich_text_available | ( | const Glib::RefPtr<TextBuffer>& | buffer | ) | const

Test to see if there is rich text available to be pasted This is done by requesting the TARGETS atom and checking if it contains any of the supported rich text targets.

This function waits for the data to be received using the main loop, so events, timeouts, etc, may be dispatched during the wait.

This function is a little faster than calling gtk_clipboard_wait_for_rich_text() since it doesn't need to retrieve the actual text.

Parameters:

  | buffer | A Gtk::TextBuffer.

Returns:
  `true` is there is rich text available, `false` otherwise.

Since gtkmm 2.10:

bool Gtk::Clipboard::wait_is_target_available | ( | const Glib::ustring & | target | ) |

Checks if a clipboard supports pasting data of a given type.

This function can be used to determine if a "Paste" menu item should be insensitive or not.

If you want to see if there's text available on the clipboard, use gtk_clipboard_wait_is_text_available() instead.

Parameters:

  | target | A Gdk::Atom indicating which target to look for.

Returns:
  `true` if the target is available, `false` otherwise.

Since gtkmm 2.6:

bool Gtk::Clipboard::wait_is_text_available | ( |  | ) | const

Test to see if there is text available to be pasted This is done by requesting the TARGETS atom and checking if it contains any of the supported text targets.

This function waits for the data to be received using the main loop, so events, timeouts, etc, may be dispatched during the wait.

This function is a little faster than calling gtk_clipboard_wait_for_text() since it doesn't need to retrieve the actual text.

Returns:
  `true` is there is text available, `false` otherwise.

## Friends And Related Function Documentation

Glib::RefPtr<Gtk::Clipboard> wrap | ( | GtkClipboard * | object,
|  | bool | take_copy = `false` |
| ) |  |  | `[related]`

A Glib::wrap() method for this object.

Parameters:

  | object | The C instance.
  | take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns:
  A C++ instance that wraps this C instance.

The documentation for this class was generated from the following file:

- clipboard.h